// $Id: ErrorTool.cpp,v 1.2 2006/01/10 19:53:58 hmd Exp $
// ============================================================================
// Include files
// ============================================================================
// GaudiKernel
// ============================================================================
#include "GaudiKernel/ToolFactory.h" 
// ============================================================================
// local
// ============================================================================
#include "ErrorTool.h"
// ============================================================================

// ============================================================================
/** @file 
 * Implementation file for class : ErrorTool
 * @date 2004-06-28 
 * @author Vanay  BELYAEV Ivan.Belyaev@itep.ru
 */
// ============================================================================

// ============================================================================
// Declaration of the Tool Factory
// ============================================================================
DECLARE_TOOL_FACTORY(ErrorTool)
// ============================================================================

// ============================================================================
/** Standard constructor
 *  @see GaudiTool 
 *  @see   AlgTool
 *  @param type   tool type (?)
 *  @param name   tool name 
 *  @param parent pointer to parent component 
 */
// ============================================================================
ErrorTool::ErrorTool( const std::string& type,
                      const std::string& name,
                      const IInterface* parent )
  : GaudiTool ( type, name , parent )
{
  declareInterface<IErrorTool>(this);
}
// ============================================================================

// ============================================================================
/// virtual and protected destrcutor 
// ============================================================================
ErrorTool::~ErrorTool() {}
// ============================================================================
