// $Id: GaudiTupleAlg.cpp,v 1.6 2005/09/23 16:14:20 hmd Exp $
// ============================================================================
// Include files
// ============================================================================
// GaudiAlg
// ============================================================================
#include "GaudiAlg/GaudiTupleAlg.h"
// ============================================================================

// ============================================================================
/*  @file GaudiTupleAlg.cpp
 *
 *  Implementation file for class : GaudiTupleAlg
 * 
 *  @date 2004-01-23 
 *  @author Vanya BELYAEV Ivan.Belyaev@itep.ru
 *  @author Chris Jones   Christopher.Rob.Jones@cern.ch
 */
// ============================================================================

// ============================================================================
// Force creation of templated class
#include "GaudiAlg/GaudiTuples.icpp"
template class GaudiTuples<GaudiHistoAlg> ;
// ============================================================================

// ============================================================================
// Standard constructor
// ============================================================================
GaudiTupleAlg::GaudiTupleAlg( const std::string& name ,
                              ISvcLocator*       svc  )
  : GaudiTuples<GaudiHistoAlg> ( name , svc ) { }
// ============================================================================

// ============================================================================
/// destructor 
// ============================================================================
GaudiTupleAlg::~GaudiTupleAlg() { } 
// ============================================================================

// ============================================================================
// standard initialization method
// ============================================================================
StatusCode GaudiTupleAlg::initialize() 
{
  // initialize the base class and return
  return GaudiTuples<GaudiHistoAlg>::initialize();
}
// ============================================================================

// ============================================================================
// standard finalization method
// ============================================================================
StatusCode GaudiTupleAlg::finalize() 
{
  // finalize the base class and return
  return GaudiTuples<GaudiHistoAlg>::finalize();
}
// ============================================================================

// ============================================================================
// The END
// ============================================================================
